#include "Motion/WalkMC.h"
#ifdef TGT_HAS_WALK

#include "Crew/Pilot.h"
#include "Events/PilotEvent.h"

#include "PilotNode.h"

void PilotNode::preStart() {
  VisualRoutinesStateNode::preStart();
  cancelFlag = false;
  const PilotRequest *p = tryExtractSignal<PilotRequest>(event);
  if ( p )
    pilotreq = *p;
}

void PilotNode::postStart() {
  VisualRoutinesStateNode::postStart();
  if ( !cancelFlag ) {
    erouter->addListener(this, EventBase::pilotEGID, (size_t)this, EventBase::statusETID);
    pilot->executeRequest(this,pilotreq);
  }
}

void PilotNode::stop() {
  pilot->pilotPop();  // in case the request was still executing when we exited
  VisualRoutinesStateNode::stop();
}

void PilotNode::doEvent() {
  postStateCompletion();
}

void PilotNode::cancelThisRequest() {
  cancelFlag = true;
  postStateFailure();
}

#endif
